#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	domoticz
Version		:	2024.7
Release		:	17.2.0.rel%{?dist}
Summary		:	Open source Home Automation System
Group		:	Application

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv3+
URL		:	http://www.domoticz.com
			#https://github.com/domoticz/domoticz/releases

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	boost-devel
BuildRequires	:	cereal-devel
BuildRequires	:	cmake
BuildRequires	:	gcc-c++
BuildRequires	:	jsoncpp-devel
BuildRequires	:	mosquitto-devel
BuildRequires	:	openzwave-devel
BuildRequires	:	pkg-config
BuildRequires	:	python3
BuildRequires	:	sqlite
BuildRequires	:	tinyxpath-devel

Requires	:	shadow

#-----------------------------------------------------------------------------
%description
Domoticz is a Home Automation System that lets you monitor
and configure various devices like: Lights, Switches, various
sensors/meters like Temperature, Rain, Wind, UV, Electra, Gas,
Water and much more. Notifications/Alerts can be sent to
any mobile device


#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc README.md
%license License.txt
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}.conf
%attr(6511,%{name},%{name}) %{_sbindir}/%{name}
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%dir %attr(0755,%{name},%{name}) %{_var}/lib/%{name}
%config(noreplace) %attr(0644,%{name},%{name}) %{_var}/lib/%{name}/%{name}.db
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
#log boot
%config(noreplace) %{_var}/log/%{name}/%{name}
#web site
%{_datadir}/%{name}/www/app/*.js
%{_datadir}/%{name}/www/app/components/*
%{_datadir}/%{name}/www/app/devices/*
%{_datadir}/%{name}/www/app/events/*
%{_datadir}/%{name}/www/app/hardware/setup/*
%{_datadir}/%{name}/www/app/hardware/Hardware*
%{_datadir}/%{name}/www/app/hardware/extra/*
%{_datadir}/%{name}/www/app/log/*
%{_datadir}/%{name}/www/app/notifications/*
%{_datadir}/%{name}/www/app/plans/*
%{_datadir}/%{name}/www/app/report/*
%{_datadir}/%{name}/www/app/scenes/*
%{_datadir}/%{name}/www/app/timers/*
%{_datadir}/%{name}/www/css/*.css
%{_datadir}/%{name}/www/css/fonts/*
%{_datadir}/%{name}/www/css/images/*.{jpg,png}
%{_datadir}/%{name}/www/css/images/spacer.gif
%{_datadir}/%{name}/www/css/ui-darkness/*.css
%{_datadir}/%{name}/www/css/ui-darkness/images/*.{gif,png}
%{_datadir}/%{name}/www/font-awesome/css/*.css
%{_datadir}/%{name}/www/font-awesome/webfonts/*
%{_datadir}/%{name}/www/favicon.ico
%{_datadir}/%{name}/www/i18n/%{name}-*.json.gz
%{_datadir}/%{name}/www/images/*.{jpg,png}
%{_datadir}/%{name}/www/images/evohome/*.png
%{_datadir}/%{name}/www/images/floorplans/example.jpg
%{_datadir}/%{name}/www/images/logo/*.png
%{_datadir}/%{name}/www/images/startup/*.png
%{_datadir}/%{name}/www/index.html
%{_datadir}/%{name}/www/js/*.{gz,js}
%{_datadir}/%{name}/www/js/ace/*.{gz,js}
%{_datadir}/%{name}/www/js/ace/LICENSE
%{_datadir}/%{name}/www/js/ace/README.md
%{_datadir}/%{name}/www/js/ace/snippets/*.js
%{_datadir}/%{name}/www/js/blockly/*.js
%{_datadir}/%{name}/www/js/blockly/msg/*.js
%{_datadir}/%{name}/www/js/data-tables/*.gz
%{_datadir}/%{name}/www/js/highcharts/*.gz
%{_datadir}/%{name}/www/js/highcharts/modules/*
%{_datadir}/%{name}/www/js/highcharts/themes/*
%{_datadir}/%{name}/www/js/noty/*.{css,gz,js}
%{_datadir}/%{name}/www/js/zip-without-map.sh
%{_datadir}/%{name}/www/manifest.json
%{_datadir}/%{name}/www/media/*
%{_datadir}/%{name}/www/ozwcp/cp.*
%{_datadir}/%{name}/www/robots.txt
%{_datadir}/%{name}/www/secpanel/css/*.css
%{_datadir}/%{name}/www/secpanel/font/*
%{_datadir}/%{name}/www/secpanel/img/bg.jpg
%{_datadir}/%{name}/www/secpanel/js/ion.sound.min.js.gz
%{_datadir}/%{name}/www/secpanel/media/*
%{_datadir}/%{name}/www/secpanel/*.html
%{_datadir}/%{name}/www/service-worker.js
%{_datadir}/%{name}/www/styles/default/*.{css,js}
%{_datadir}/%{name}/www/styles/default/images/*.png
%{_datadir}/%{name}/www/styles/dark-th3me/*.{css,js}
%{_datadir}/%{name}/www/styles/dark-th3me/fonts/*.ttf
%{_datadir}/%{name}/www/styles/dark-th3me/images/%{name}.jpg
%{_datadir}/%{name}/www/styles/elemental/custom.*
%{_datadir}/%{name}/www/styles/elemental/fonts/*.ttf
%{_datadir}/%{name}/www/styles/elemental/images/*.{jpg,png}
%{_datadir}/%{name}/www/styles/element-*/*.{css,js}
%{_datadir}/%{name}/www/styles/element-*/fonts/*.ttf
%{_datadir}/%{name}/www/styles/element-*/images/*.jpg
%{_datadir}/%{name}/www/styles/simple-*/*.{css,js}
%{_datadir}/%{name}/www/switch_icons.txt
%{_datadir}/%{name}/www/templates/custom.example
%{_datadir}/%{name}/www/templates/angular.example
%{_datadir}/%{name}/www/templates/readme.txt
%{_datadir}/%{name}/www/views/*.html
#internal data
%{_datadir}/%{name}/dzVents/documentation/*
%{_datadir}/%{name}/dzVents/runtime/*.lua
%{_datadir}/%{name}/dzVents/runtime/device-adapters/*.lua
%{_datadir}/%{name}/dzVents/runtime/integration-tests/README.md
%{_datadir}/%{name}/dzVents/runtime/integration-tests/package.json
%{_datadir}/%{name}/dzVents/runtime/integration-tests/server.js
%{_datadir}/%{name}/dzVents/runtime/integration-tests/*.lua
%{_datadir}/%{name}/dzVents/runtime/misc/*
%{_datadir}/%{name}/dzVents/runtime/tests/README.md
%{_datadir}/%{name}/dzVents/runtime/tests/testfile
%{_datadir}/%{name}/dzVents/runtime/tests/data/README.md
%{_datadir}/%{name}/dzVents/runtime/tests/generated_scripts/*.lua
%{_datadir}/%{name}/dzVents/runtime/tests/.luacov
%{_datadir}/%{name}/dzVents/runtime/tests/*.lua
%{_datadir}/%{name}/dzVents/runtime/tests/scandir/*.lua
%{_datadir}/%{name}/dzVents/runtime/tests/scripts/*.lua
%{_datadir}/%{name}/dzVents/runtime/todo.md
%{_datadir}/%{name}/dzVents/runtime/xmlhandler/*.lua
%{_datadir}/%{name}/scripts/buienradar_rain_example.pl
%{_datadir}/%{name}/scripts/_%{name}_*
%{_datadir}/%{name}/scripts/%{name}.conf
%{_datadir}/%{name}/scripts/download_update.sh
%{_datadir}/%{name}/scripts/dzVents/data/README.md
%{_datadir}/%{name}/scripts/dzVents/examples/*.lua
%{_datadir}/%{name}/scripts/dzVents/generated_scripts/README.md
%{_datadir}/%{name}/scripts/dzVents/scripts/README.md
%{_datadir}/%{name}/scripts/logrotate/%{name}
%{_datadir}/%{name}/scripts/lua/*.lua
%{_datadir}/%{name}/scripts/lua_parsers/readme.txt
%{_datadir}/%{name}/scripts/lua_parsers/*.lua
%{_datadir}/%{name}/scripts/python/*.py
%{_datadir}/%{name}/scripts/install.sh
%{_datadir}/%{name}/scripts/readme.txt
%{_datadir}/%{name}/scripts/restart_%{name}
%{_datadir}/%{name}/scripts/update_%{name}
%{_datadir}/%{name}/scripts/support/*
%{_datadir}/%{name}/scripts/templates/*.Lua
%{_datadir}/%{name}/scripts/templates/*.dzVents
%{_datadir}/%{name}/scripts/templates/All.Python
%{_datadir}/%{name}/plugins/AwoxSMP/*.py
%{_datadir}/%{name}/plugins/AwoxSMP/lib/*.py
%{_datadir}/%{name}/plugins/examples/*.py
%{_datadir}/%{name}/server_cert.pem
%{_datadir}/%{name}/updatedomo

#-----------------------------------------------------------------------------
%pre 
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{name}) ]; then
    /usr/sbin/groupadd						\
	-K GID_MIN=50						\
	-K GID_MAX=99						\
	 %{name}

    /usr/sbin/useradd 						\
	-r							\
	-c "Domoticz Home Automation Server"			\
	-K SYS_UID_MIN=50					\
	-K SYS_UID_MAX=99					\
	-g %{name}						\
	-s /sbin/nologin					\
	-d %{_datadir}/%{name}					\
	%{name}
    fi
  fi

#after upgrade or remove
%preun 
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}
  /usr/sbin/userdel %{name}
  /usr/sbin/groupdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post
%{_sbindir}/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%prep
%setup -q
#patch1 -p1
#patch2 -p1
tar xf %{SOURCE1}
#-----------------------------------------------------------------------------
#building application
%build

cmake 							\
	-B _bld						\
	-G Ninja					\
	-S .						\
	-DCMAKE_BUILD_TYPE=RelWithDebInfo		\
	-DUSE_STATIC_LIBSTDCXX=NO			\
	-DUSE_STATIC_OPENZWAVE=NO			\
	-DUSE_OPENSSL_STATIC=NO				\
	-DUSE_BUILTIN_JSONCPP=NO			\
	-DUSE_BUILTIN_MINIZIP=NO			\
	-DUSE_BUILTIN_MQTT=NO				\
	-DUSE_BUILTIN_SQLITE=NO				\
	-DUSE_STATIC_BOOST=NO				\
	-DCMAKE_INSTALL_PREFIX=%{_datadir}/%{name}	\

cmake							\
	--build						\
	_bld						\
	--parallel %(/usr/bin/getconf _NPROCESSORS_ONLN)\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	cmake						\
	--install _bld					\

# remove docs, we grab them via %doc
%{__rm} -f %{buildroot}%{_datadir}/%{name}/*.txt


# remove uneeded files
pushd %{buildroot}%{_datadir}/%{name}/dzVents

# remove git information
%{__rm} -fr							\
	 .gitignore						\
	 ../scripts/dzVents/dumps
	
	

# remove empty file
%{__rm} -f							\
	runtime/tests/scandir/.f3.lua*				\
	runtime/tests/scandir/f1lua
	 
popd

#preparing config file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/sysconfig
%{__cp}								\
	%{name}-ok_addon/%{name}.conf				\
	%{buildroot}%{_sysconfdir}/sysconfig

# move binary to standard directory
%{__mkdir_p} %{buildroot}%{_sbindir}
%{__mv}								\
	%{buildroot}%{_datadir}/%{name}/%{name}			\
	%{buildroot}%{_sbindir}

#preparing service file	
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp}								\
	%{name}-ok_addon/%{name}				\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#preparing service file	
%{__mkdir_p} %{buildroot}%{_var}/lib/%{name}
touch %{buildroot}%{_var}/lib/%{name}/%{name}.db

#preparing log rotation
%{__mkdir_p} %{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} 							\
	%{name}-ok_addon/%{name}.logrotate			\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%{__mkdir_p} %{buildroot}%{_var}/log/%{name}
touch %{buildroot}%{_var}/log/%{name}/%{name}

#-----------------------------------------------------------------------------
%changelog
